/*
   Move the definition of the Comparator
   into this file as a private class.
*/
import java.util.*;

public class ComparatorTester1
{
   public static void main(String[] args)
   {
      ArrayList<Country> countries = new ArrayList<Country>();
      countries.add(new Country("Uruguay", 176220));
      countries.add(new Country("Thailand", 514000));
      countries.add(new Country("Belgium", 30510));

      // Create an instance of our private class.
      Comparator<Country> comp = new CountryComparatorByName();

      // Call the sort() method and pass it the comparator object.
      Collections.sort(countries, comp);

      // Call the sort() method and pass it an anonymous comparator object.
      Collections.sort(countries, new CountryComparatorByName());

      // Now the array list is sorted by name
      for (Country c : countries)
         System.out.println(c.getName() + " " + c.getArea());
   }
}


/**
  This is now a private class (it is not an inner class).
*/
class CountryComparatorByName implements Comparator<Country>
{
   public int compare(Country country1, Country country2)
   {
      return country1.getName().compareTo(country2.getName());
   }
}

/*
   NOTE: In the folder sort2, the class
         CountryComparatorByName.java
         is a public class in a separate
         file. Otherwise, it is exactly
         like this private version of
         CountryComparatorByName.
*/