/*
   Move the definition of the Comparator into the
   body of the main() method as a nested class.
*/
import java.util.*;

public class ComparatorTester2
{
   public static void main(String[] args)
   {
      ArrayList<Country> countries = new ArrayList<Country>();
      countries.add(new Country("Uruguay", 176220));
      countries.add(new Country("Thailand", 514000));
      countries.add(new Country("Belgium", 30510));

      // This is a (named) inner class (see page 149 of the textbook).
      class CountryComparatorByName implements Comparator<Country>
      {
         public int compare(Country country1, Country country2)
         {
            return country1.getName().compareTo(country2.getName());
         }
      }

      // Create an instance of our inner class and name it comp.
      Comparator<Country> comp = new CountryComparatorByName();

      // Call the sort() method and pass it the comparator object.
      Collections.sort(countries, comp);

      // Call the sort() method and pass it an anonymous comparator object.
      Collections.sort(countries, new CountryComparatorByName());

      // Now the array list is sorted by name
      for (Country c : countries)
         System.out.println(c.getName() + " " + c.getArea());
   }
}

