/*
   Move the definition of the Comparator
   into an anonymous inner class.
*/
import java.util.*;

public class ComparatorTester3
{
   public static void main(String[] args)
   {
      ArrayList<Country> countries = new ArrayList<Country>();
      countries.add(new Country("Uruguay", 176220));
      countries.add(new Country("Thailand", 514000));
      countries.add(new Country("Belgium", 30510));

      // This is an anonymous inner class (see page 149 of the textbook).
      // Note: The inner class is anonymous, but the object is named comp.
      Comparator<Country> comp = new
         Comparator<Country>()
         {
            public int compare(Country country1, Country country2)
            {
               return country1.getName().compareTo(country2.getName());
            }
         };

      // Call the sort() method and pass it the comparator object.
      Collections.sort(countries, comp);

      // Now the array list is sorted by name
      for (Country c : countries)
         System.out.println(c.getName() + " " + c.getArea());
   }
}

