/*
   Move the definition of the Comparator into an
   anonymous lambda expression at the call to sort().
*/
import java.util.*;

public class ComparatorTester4
{
   public static void main(String[] args)
   {
      ArrayList<Country> countries = new ArrayList<Country>();
      countries.add(new Country("Uruguay", 176220));
      countries.add(new Country("Thailand", 514000));
      countries.add(new Country("Belgium", 30510));

      // NOTE: This IS NOT really Java! (At least not yet. Maybe in Java 8.)
      // Call the sort() method and pass it an anonymous lambda expression
      // that implements the one method from the Comparator interface.
      Collections.sort( countries, (c1, c2) -> c1.getName().compareTo(c2.getName()) );

      // Now the array list is sorted by name
      for (Country c : countries)
         System.out.println(c.getName() + " " + c.getArea());
   }
}